//
//  ViewController.m
//  LYPlateKeyboard
//
//  Created by 乐浩 on 2017/11/9.
//  Copyright © 2017年 RBJR. All rights reserved.
//

#import "ViewController.h"

#import "LYPlateKeyBoardView.h"

@interface ViewController ()<LYPlateKeyBoardViewDelegate, UITextFieldDelegate>

@property (weak, nonatomic) IBOutlet UITextField *plateTF;
@property (weak, nonatomic) IBOutlet UITextField *testTF;

@property (nonatomic, strong) LYPlateKeyBoardView *keyboardView;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    [self.plateTF addObserver:self forKeyPath:@"text" options:NSKeyValueObservingOptionNew  context:nil];
}

- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary<NSKeyValueChangeKey,id> *)change context:(void *)context {
    
    NSLog(@"LY >>>>>  text --- %@", change[@"new"]);
    NSLog(@"LY >>>>>  self.plateTF.text --- %@", self.plateTF.text);
    
    if (self.plateTF.text.length > 7) {
        NSString *str = [self.plateTF.text substringFromIndex:self.plateTF.text.length - 1];
        self.plateTF.text = [self.plateTF.text stringByReplacingOccurrencesOfString:str withString:@""];
    }
    [[NSNotificationCenter defaultCenter] postNotificationName:@"abc" object:nil userInfo:@{@"text": change[@"new"]}];
    
}

- (IBAction)btnClick:(id)sender {
    
    self.keyboardView = [[LYPlateKeyBoardView alloc] initWithFrame:[UIScreen mainScreen].bounds];
    self.keyboardView.delegate = self;
    [self.view addSubview:self.keyboardView];
    
}

- (void)clickWithString:(NSString *)string {
    
    NSLog(@"self.plateTF.text -- %@", self.plateTF.text);
    self.testTF.text = [self.plateTF.text stringByAppendingString:string];
    
    self.plateTF.text = [self.plateTF.text stringByAppendingString:string];
}

- (void)deleteBtnClick {
    
    if (self.plateTF.text.length == 0) {
        
        
    }else if (self.plateTF.text.length == 1) {
        [self.keyboardView deleteEnd];
        self.plateTF.text = [self.plateTF.text substringToIndex:[self.plateTF.text length] - 1];
    }else {
        self.plateTF.text = [self.plateTF.text substringToIndex:[self.plateTF.text length] - 1];
    }
}

- (void)checkTF {
    
    NSLog(@"LY >>>>>>> 1111111111");
    
    if (self.plateTF.text.length == 0) {
        [[NSNotificationCenter defaultCenter] postNotificationName:@"abcBtnClicNotify" object:nil userInfo:@{@"text":@""}];
    }else {
        [[NSNotificationCenter defaultCenter] postNotificationName:@"abcBtnClicNotify" object:nil userInfo:@{@"text":self.plateTF.text}];
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}


@end
